/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Cached.xs. Do not edit this file, edit Cached.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Cached.xs"
#include "EXTERN.h"
#include "perl.h"

/*
 * chocolateboy 2009-02-08
 *
 * for binary compatibility (see perlapi.h), XS modules perform a function call to
 * access each and every interpreter variable. So, for instance, an innocuous-looking
 * reference to PL_op becomes:
 *
 *     (*Perl_Iop_ptr(my_perl))
 *
 * This (obviously) impacts performance. Internally, PL_op is accessed as:
 *
 *     my_perl->Iop
 *
 * (in threaded/multiplicity builds (see intrpvar.h)), which is significantly faster.
 *
 * defining PERL_CORE gets us the fast version, at the expense of a future maintenance release
 * possibly breaking things: http://www.xray.mpe.mpg.de/mailing-lists/perl5-porters/2008-04/msg00171.html
 *
 * Rather than globally defining PERL_CORE, which pokes its fingers into various headers, exposing
 * internals we'd rather not see, just define it for XSUB.h, which includes
 * perlapi.h, which imposes the speed limit.
 */

#define PERL_CORE
#include "XSUB.h"
#undef PERL_CORE

#include "ppport.h"

#include "hook_op_check.h"
#include "hook_op_annotation.h"

#define GOTO_CACHED_KEY "Goto::Cached"

STATIC hook_op_check_id GOTO_CACHED_CHECK_ID = 0;
STATIC OPAnnotationGroup GOTO_CACHED_ANNOTATIONS = NULL;
STATIC OP * goto_cached_check(pTHX_ OP *o, void *user_data);
STATIC OP * goto_cached_dynamic(pTHX);
STATIC OP * goto_cached_static_fast(pTHX);
STATIC OP * goto_cached_static(pTHX);
STATIC U32 GOTO_CACHED_CHECK_ENABLED = 0;
STATIC void goto_cached_data_destructor(pTHX_ void *data);

STATIC void goto_cached_data_destructor(pTHX_ void *data) {
    HV *hv = (HV *)data;
    hv_clear(hv);
    hv_undef(hv);
}

/* XXX calling the next OP's op_ppaddr directly is no faster in my tests */
STATIC OP* goto_cached_static_fast(pTHX) {
    return (PL_op->op_next);
}

STATIC OP* goto_cached_static(pTHX) {
    OP * nextop;
    OPAnnotation * annotation = op_annotation_get(GOTO_CACHED_ANNOTATIONS, PL_op);
    nextop = (annotation->op_ppaddr)(aTHX);

    if (PL_lastgotoprobe) { /* target is not in scope: disable caching */
        PL_op->op_ppaddr = annotation->op_ppaddr;
    } else {
        PL_op->op_next = nextop;
        PL_op->op_ppaddr = goto_cached_static_fast;
    }

    op_annotation_delete(aTHX_ GOTO_CACHED_ANNOTATIONS, PL_op); /* not needed anymore */

    return nextop;
}

STATIC OP* goto_cached_dynamic(pTHX) {
    dSP;
    SV * sv = TOPs;
    OP * nextop = NULL;
    OPAnnotation * annotation = op_annotation_get(GOTO_CACHED_ANNOTATIONS, PL_op);

    if (SvROK(sv)) { /* goto SUB: disable caching */
        PL_op->op_ppaddr = annotation->op_ppaddr;
        nextop = (PL_op->op_ppaddr)(aTHX);
        op_annotation_delete(aTHX_ GOTO_CACHED_ANNOTATIONS, PL_op); /* not needed anymore */
    } else if (annotation->data) { /* there is a cache for this op */
        SV ** svp;
        HV *hv = (HV *)(annotation->data);
        STRLEN len;
        const char * label = SvPV_const(sv, len);

        svp = hv_fetch(hv, label, len, 0);

        if (svp && *svp && SvOK(*svp)) {
            nextop = INT2PTR(OP *, SvIVX(*svp));
        } else {
            nextop = (annotation->op_ppaddr)(aTHX);

            if (PL_lastgotoprobe) { /* target is not in scope: disable caching */
                PL_op->op_ppaddr = annotation->op_ppaddr;
                op_annotation_delete(aTHX_ GOTO_CACHED_ANNOTATIONS, PL_op); /* not needed anymore */
            } else {
                (void)hv_store(hv, label, len, newSVuv(PTR2UV(nextop)), 0);
            }
        }
    } else { /* initialize cache */
        nextop = (annotation->op_ppaddr)(aTHX);

        if (PL_lastgotoprobe) { /* target is not in scope: disable caching */
            PL_op->op_ppaddr = annotation->op_ppaddr;
            op_annotation_delete(aTHX_ GOTO_CACHED_ANNOTATIONS, PL_op); /* not needed anymore */
        } else {
            STRLEN len;
            char * label = SvPV(sv, len);
            HV * hv = newHV();
            (void)hv_store(hv, label, len, newSVuv(PTR2UV(nextop)), 0);
            annotation->data = hv;
            annotation->dtor = goto_cached_data_destructor;
        }
    }

    return nextop;
}

STATIC OP *goto_cached_check(pTHX_ OP *o, void *user_data) {
    PERL_UNUSED_ARG(user_data);

    if ((o->op_type == OP_GOTO) && (PL_hints & 0x020000)) {
        SV ** svp;
        HV * table = GvHVn(PL_hintgv);

        if (table && (svp = hv_fetch(table, GOTO_CACHED_KEY, 12, FALSE)) && *svp && SvOK(*svp)) {
            op_annotate(GOTO_CACHED_ANNOTATIONS, o, NULL, NULL);
            o->op_ppaddr = (o->op_flags & OPf_STACKED) ?
                goto_cached_dynamic :
                goto_cached_static;
        }
    }

    return o;
}

#line 152 "Cached.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 296 "Cached.c"

XS_EUPXS(XS_Goto__Cached_END); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Goto__Cached_END)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 153 "Cached.xs"
        if (GOTO_CACHED_ANNOTATIONS) { /* make sure it was initialised */
            op_annotation_group_free(aTHX_ GOTO_CACHED_ANNOTATIONS);
        }
#line 309 "Cached.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Goto__Cached__enter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Goto__Cached__enter)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 161 "Cached.xs"
        if (GOTO_CACHED_CHECK_ENABLED == 0) {
            GOTO_CACHED_CHECK_ID = hook_op_check(OP_GOTO, goto_cached_check, NULL);
        }
        ++GOTO_CACHED_CHECK_ENABLED;
#line 327 "Cached.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Goto__Cached__leave); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Goto__Cached__leave)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 170 "Cached.xs"
        --GOTO_CACHED_CHECK_ENABLED;
        if (GOTO_CACHED_CHECK_ENABLED == 0) {
            hook_op_check_remove(OP_GOTO, GOTO_CACHED_CHECK_ID);
        }
#line 345 "Cached.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Goto__Cached); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Goto__Cached)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Goto::Cached::END", XS_Goto__Cached_END, file, "");
        (void)newXSproto_portable("Goto::Cached::_enter", XS_Goto__Cached__enter, file, "");
        (void)newXSproto_portable("Goto::Cached::_leave", XS_Goto__Cached__leave, file, "");

    /* Initialisation Section */

#line 147 "Cached.xs"
    GOTO_CACHED_ANNOTATIONS = op_annotation_group_new();

#line 387 "Cached.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

